﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {

        private static System.Windows.Forms.Timer tmrDisplay;       //表示更新用タイマ
        private const int c_PROCESS_INTERVAL = 100;                 // 表示処理周期

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {

            int ret;
            Measurement mea = new Measurement();
            try
            {
                ret = mea.MeasurementStop();
            }
            catch
            {
            }
            finally
            { }
        }

        /// <summary>
        /// ファイル-選手データ読み込み 選択時にファイルを開くダイアログを表示してファイルを選択する
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mnuFileDriverRead_Click(object sender, EventArgs e)
        {
            //OpenFileDialogクラスのインスタンスを作成
            OpenFileDialog ofd = new OpenFileDialog();

            //はじめに表示されるフォルダを指定する
            //指定しない（空の文字列）の時は、現在のディレクトリが表示される
            //ofd.InitialDirectory = @"C:\";
            //[ファイルの種類]に表示される選択肢を指定する
            //指定しないとすべてのファイルが表示される
            ofd.Filter =
                "CSVファイル(*.csv)|*.csv|すべてのファイル(*.*)|*.*";
            //[ファイルの種類]ではじめに
            //「CSVファイル」が選択されているようにする
            ofd.FilterIndex = 1;
            //タイトルを設定する
            ofd.Title = "開くファイルを選択してください";
            //ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
            ofd.RestoreDirectory = true;
            //存在しないファイルの名前が指定されたとき警告を表示する
            //デフォルトでTrueなので指定する必要はない
            ofd.CheckFileExists = true;
            //存在しないパスが指定されたとき警告を表示する
            //デフォルトでTrueなので指定する必要はない
            ofd.CheckPathExists = true;

            //ダイアログを表示する
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                //OKボタンがクリックされたとき
                //選択されたファイル名を表示する
                Register reg = new Register();
                reg.DriverFile_Read(ofd.FileName, dgvDriver);
                reg.DriverDataCopy(dgvTime, dgvDriver);
            }
        }

        private void mnuFileDriverSave_Click(object sender, EventArgs e)
        {
            //SaveFileDialogクラスのインスタンスを作成
            SaveFileDialog sfd = new SaveFileDialog();

            //はじめに表示されるフォルダを指定する
            //sfd.InitialDirectory = @"C:\";
            //[ファイルの種類]に表示される選択肢を指定する
            sfd.Filter =
                "CSVファイル(*.csv)|*.csv|すべてのファイル(*.*)|*.*";
            //[ファイルの種類]ではじめに
            //「すべてのファイル」が選択されているようにする
            sfd.FilterIndex = 1;
            //タイトルを設定する
            sfd.Title = "保存先のファイルを選択してください";
            //ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
            sfd.RestoreDirectory = true;
            //既に存在するファイル名を指定したとき警告する
            //デフォルトでTrueなので指定する必要はない
            sfd.OverwritePrompt = true;
            //存在しないパスが指定されたとき警告を表示する
            //デフォルトでTrueなので指定する必要はない
            sfd.CheckPathExists = true;

            //ダイアログを表示する
            if (sfd.ShowDialog() == DialogResult.OK)
            {
                //OKボタンがクリックされたとき
                //選択されたファイル名を表示する
                Register reg = new Register();
                reg.DriverFile_Save(sfd.FileName, dgvDriver);
            }
        }

        private void mnuFileTimeSave_Click(object sender, EventArgs e)
        {

        }

        private void mnuFileExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void mnuDataclearALL_Click(object sender, EventArgs e)
        {

        }

        private void mnuDataclearPC_Click(object sender, EventArgs e)
        {

        }

        private void mnuComSetting_Click(object sender, EventArgs e)
        {

        }

        private void mnuHelpVersion_Click(object sender, EventArgs e)
        {

        }

        private void btnComStart_Click(object sender, EventArgs e)
        {
            int ret;
            Measurement mea = new Measurement();
            try
            {
                btnComStart.Enabled = false;
                btnComStop.Enabled = true;
                ret = mea.MeasurementStart();
                ret = DisplayStart();
            }
            catch
            {    
                btnComStart.Enabled =true;
                btnComStop.Enabled = false;
            }
            finally
            { }
        }

        private void btnComStop_Click(object sender, EventArgs e)
        {
            int ret;
            Measurement mea = new Measurement();
            try
            {
                btnComStart.Enabled = true;
                btnComStop.Enabled = false;
                ret = mea.MeasurementStop();
                ret = DisplayStop();
            }
            catch
            {
                btnComStart.Enabled = false;
                btnComStop.Enabled = true;
            }
            finally
            { }
        }

        /// <summary>
        /// 選手データタブの入力で数値のみに制限するセルの設定
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvDriver_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {
            //表示されているコントロールがDataGridViewTextBoxEditingControlか調べる
            if (e.Control is DataGridViewTextBoxEditingControl)
            {
                DataGridView dgv = (DataGridView)sender;

                //編集のために表示されているコントロールを取得
                DataGridViewTextBoxEditingControl tb =
                    (DataGridViewTextBoxEditingControl)e.Control;

                //イベントハンドラを削除
                tb.KeyPress -=
                    new KeyPressEventHandler(dgvTextBox_KeyPress);

                //該当する列か調べる
                if (dgv.CurrentCell.OwningColumn.Name == "ColumnDr_CarNo")
                {
                    //KeyPressイベントハンドラを追加
                    tb.KeyPress +=
                        new KeyPressEventHandler(dgvTextBox_KeyPress);
                }
            }
        }

        /// <summary>
        /// 計測時間タブの入力で数値のみに制限するセルの設定
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvTime_EditingControlShowing(object sender, DataGridViewEditingControlShowingEventArgs e)
        {

            //表示されているコントロールがDataGridViewTextBoxEditingControlか調べる
            if (e.Control is DataGridViewTextBoxEditingControl)
            {
                DataGridView dgv = (DataGridView)sender;

                //編集のために表示されているコントロールを取得
                DataGridViewTextBoxEditingControl tb =
                    (DataGridViewTextBoxEditingControl)e.Control;

                //イベントハンドラを削除
                tb.KeyPress -=
                    new KeyPressEventHandler(dgvTextBox_KeyPress);

                //該当する列か調べる
                if (dgv.CurrentCell.OwningColumn.Name == "ColumnTime_CarNo")
                {
                    //KeyPressイベントハンドラを追加
                    tb.KeyPress +=
                        new KeyPressEventHandler(dgvTextBox_KeyPress);
                }
            }
        }

        /// <summary>
        /// DataGridViewに表示されているテキストボックスの入力を数値のみに制限
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void dgvTextBox_KeyPress(object sender,
            KeyPressEventArgs e)
        {
            //数字しか入力できないようにする
            if (e.KeyChar < '0' || e.KeyChar > '9')
            {
                e.Handled = true;
            }
        }

        /// <summary>
        /// 計測値の画面更新を開始する
        /// </summary>
        /// <returns>処理結果 0:正常 0以外:異常</returns>
        private int DisplayStart()
        {
            int ret = 0;
            try
            {
                tmrDisplay = new System.Windows.Forms.Timer();
                tmrDisplay.Tick += new EventHandler(DisplayProcess);
                tmrDisplay.Interval = c_PROCESS_INTERVAL;
                tmrDisplay.Start();

            }
            catch
            { }
            finally
            { }
            return ret;
        }

        /// <summary>
        /// 計測値の画面更新を停止する
        /// </summary>
        /// <returns>処理結果 0:正常 0以外:異常</returns>
        private int DisplayStop()
        {
            int ret = 0;
            try
            {
                tmrDisplay.Stop();
                tmrDisplay = null;
            }
            catch
            { }
            finally
            { }
            return ret;
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="myObject"></param>
        /// <param name="myEventArgs"></param>
        private void DisplayProcess(Object myObject, EventArgs myEventArgs)
        {
            int ret = 0;
            Measurement mea = new Measurement();
            int startPassNUm = 0;   //スタートした台数

            try
            {
                int UnitNum = mea.GetUnitNumber();  //光電管数を取得
                if( UnitNum < 0 )
                {   //光電管がない
                    return;
                }
                for( int UnitIndex = 0; UnitIndex < UnitNum; UnitIndex++)
                {
                    e_UNIT_TYPE em_UnitType = mea.GetUnitType(UnitIndex);   //光電管タイプを取得
                    int passNum = mea.GetPassNumber(UnitIndex);             //通過台数を取得
                    //光電管タイプがスタート
                    if (em_UnitType == e_UNIT_TYPE.START)
                    {   //スタートした台数を取得
                        startPassNUm = mea.GetPassNumber(UnitIndex);
                    }
                    else if (em_UnitType == e_UNIT_TYPE.GOAL)
                    {   //光電管タイプがゴール
                        int colCount = dgvTime.Columns.Count;
                        int rowCount = dgvTime.Rows.Count;
                        //int passIndex = 0;
                        for (int colIndex = 0; colIndex < colCount; colIndex++)
                        {
                            if (dgvTime.Columns[colIndex].Name == "ColumnTime_Time")
                            {
                                for (int rowIndex = 0; rowIndex < rowCount; rowIndex++)
                                {
                                    e_MESURE_STATUS em_Mesure_Status = mea.GetMesureStatus(UnitIndex, rowIndex);
                                    e_DISP_STATUS em_Disp_Status = mea.GetDispStatus(UnitIndex, rowIndex);
                                    if (em_Mesure_Status != e_MESURE_STATUS.UNMESURE && em_Disp_Status == e_DISP_STATUS.UNDISP)
                                    {
                                        string sTime = mea.GetTime(UnitIndex, rowIndex);
                                        dgvTime[colIndex, rowIndex].Value = sTime;

                                        ret = mea.SetDispStatus(UnitIndex, rowIndex, e_DISP_STATUS.DISP_COMP);
                                    }

                                    //計測中も表示
                                    if (em_Mesure_Status == e_MESURE_STATUS.UNMESURE && em_Disp_Status == e_DISP_STATUS.UNDISP)
                                    {
                                        string sTime = mea.GetTime(UnitIndex, rowIndex);
                                        dgvTime[colIndex, rowIndex].Value = sTime;
                                    }
                                }
                                break;
                            }
                        }
                    }

                }
            }
            catch { }
        }


        /// <summary>
        /// デバッグ表示
        /// </summary>
        /// <returns>処理結果 0:正常 0以外:異常</returns>
        public int debug_display(string para1, string para2)
        {
            int ret = 0;
            try
            {
                label1.Text = para1;
                label2.Text = para2;
            }
            catch
            { }
            finally
            { }
            return ret;
        }

    }
}
